import pygame
pygame.init()

import helpers
import random

import settings

from Raindrop import Raindrop


class Cloud( pygame.sprite.Sprite ):
	"""

	"""
	def __init__( self, _image,
						_cur_alpha,
						_alpha_reducement,
						_top_min,
						_top_max,
						_speed_min,
						_speed_max ):
		"""
		
		"""
		pygame.sprite.Sprite.__init__( self )
		
		self.image 				= helpers.load_image( _image )
		self.rect 				= self.image.get_rect()
		self.cur_alpha 			= _cur_alpha
		self.alpha_reducement 	= _alpha_reducement
		self.top_min 			= _top_min
		self.top_max 			= _top_max
		self.speed_min			= _speed_min
		self.speed_max			= _speed_max
		self.direction_left 	= False
		self.direction_right 	= False
		self.has_been_disturbed = False		

		if random.randint( 1, 2 ) == 1:
			self.direction_left = True
			self.speed = random.randint( self.speed_min, self.speed_max ) * -1
			self.rect.left = random.randint( settings.WINDOW_WIDTH, settings.WINDOW_WIDTH + self.image.get_width() )
			self.rect.top = random.randint( self.top_min, self.top_max )
		else:
			self.direction_right = True		
			self.speed = random.randint( self.speed_min, self.speed_max )
			self.rect.right = random.randint( self.image.get_width() * -1, 0 )
			self.rect.top = random.randint( self.top_min, self.top_max )


		self.image.set_alpha( self.cur_alpha )


	def collision_with_player( self, _player ):
		"""

		"""
		if self.rect.colliderect( _player.rect ):
			return True
		else:
			return False


	def update( self, _player, _raindrops ):
		"""

		"""
		if not self.has_been_disturbed and self.collision_with_player( _player ):
			self.has_been_disturbed = True
			_raindrops.add( self.create_raindrop( _raindrops ) )
			
		if not self.has_been_disturbed:
			if self.direction_left:
				if self.can_move_left():
					self.move_left()
				else:
					self.rect.left = random.randint( settings.WINDOW_WIDTH, settings.WINDOW_WIDTH + self.image.get_width() )
					self.rect.top = random.randint( self.top_min, self.top_max )

			if self.direction_right:
				if self.can_move_right():
					self.move_right()
				else:
					self.rect.right = random.randint( self.image.get_width() * -1, 0 )
					self.rect.top = random.randint( self.top_min, self.top_max )

		else:
			if self.image.get_alpha() == 0:
				self.kill()
			else:
				self.cur_alpha -= self.alpha_reducement
				self.image.set_alpha( self.cur_alpha )


	def create_raindrop( self, _raindrops ):
		"""

		"""
		raindrop = Raindrop( **settings.RAINDROP )
		raindrop.set_position_xy( self.rect.center )
		return raindrop


	def can_move_right( self ):
		"""

		"""
		if self.rect.left < settings.WINDOW_WIDTH:
			return True
		else:
			return False


	def can_move_left( self ):
		"""

		"""
		if self.rect.right > 0:
			return True
		else:
			return False


	def move_right( self ):
		"""

		"""
		self.rect.left += self.speed


	def move_left( self ):
		"""

		"""
		self.rect.right += self.speed
