import random

import pygame
pygame.init()

import helpers
import settings


class Firefly( pygame.sprite.Sprite ):
	"""

	"""
	sound = helpers.load_sound( "firefly.ogg" )
	
	def __init__( self, _image_path,
						_min_max_vertical,
						_min_max_horizontal,
						_timer,
						_timer_increment,
						_min_max_stay_in_location_time ):
		"""

		"""
		pygame.sprite.Sprite.__init__( self )

		self.image 					= helpers.load_image( _image_path )
		self.rect 					= self.image.get_rect()
		self.rect.top 				= random.randint( *_min_max_vertical )
		self.rect.left 				= random.randint( *_min_max_horizontal )
		self.stay_in_location_time 	= random.randint( *_min_max_stay_in_location_time )
		self.min_max_vertical		= _min_max_vertical
		self.min_max_horizontal		= _min_max_horizontal
		self.timer					= _timer
		self.timer_increment		= _timer_increment

		self.do_fade_out			= False
		self.do_fade_in				= True
		self.fade_out_increment		= 5
		self.fade_in_increment		= 5
		self.cur_alpha				= 0
		self.alpha_min				= 0
		self.alpha_max				= 255

		self.cur_alpha 				= self.alpha_min
		self.image.set_alpha( self.alpha_min )


	def update( self, _player ):
		"""

		"""
		if not self.do_fade_in and not self.do_fade_out:
			if self.collision_with_player( _player ):
				self.has_been_caught()
				_player.fireflies += 1
				Firefly.sound.play()
			else:
				self.increase_timer()
				if self.timer_max_reached():
					self.reset_timer()
					self.do_fade_out = True
					
		else:
			if self.do_fade_out:
				if self.faded_out():
					self.do_fade_out = False
					self.randomise_location()
					self.do_fade_in = True
				else:
					self.fade_out()

			elif self.do_fade_in:
				if self.faded_in():
					self.do_fade_in = False
				else:
					self.fade_in()


	def faded_out( self ):
		"""

		"""
		if self.cur_alpha <= self.alpha_min:
			return True
		else:
			return False


	def faded_in( self ):
		"""

		"""
		if self.cur_alpha >= self.alpha_max:
			return True
		else:
			return False


	def fade_in( self ):
		"""

		"""
		self.cur_alpha += self.fade_in_increment
		self.image.set_alpha( self.cur_alpha )


	def fade_out( self ):
		"""

		"""
		self.cur_alpha -= self.fade_out_increment
		self.image.set_alpha( self.cur_alpha )		


	def collision_with_player( self, _player ):
		"""

		"""
		if self.rect.colliderect( _player.rect ):
			return True
		else:
			return False


	def has_been_caught( self ):
		"""

		"""
		self.kill()


	def timer_max_reached( self ):
		"""

		"""
		if self.timer >= self.stay_in_location_time:
			return True
		else:
			return False


	def increase_timer( self ):
		"""

		"""
		self.timer += self.timer_increment


	def reset_timer( self ):
		"""

		"""
		self.timer = 0


	def randomise_location( self ):
		"""

		"""
		self.rect.center = (
			random.randint( *self.min_max_horizontal ),
			random.randint( *self.min_max_vertical ) )
