import math
import os
import pygame
pygame.init()

import settings

from AnimatedSprite import AnimatedSprite


class Jungleguy( pygame.sprite.Sprite ):
	"""

	"""
	def __init__( self, _images_right_dir,
						_images_left_dir,
						_animation_interval,
						_left_top_position,
						_movement_status,
						_energy,
						_normal_jump_energy,
						_massive_jump_energy,
						_movement_speed_normal,
						_jumping,
						_jump_max_speed,
						_jump_increment,
						_jump_speed_normal,
						_jump_up,
						_jump_down,
						_direction,
						_movement_speed_burst,
						_jump_speed_burst,
						_energy_recover_rate,
						_energy_recover_trigger,
						_energy_recover_counter,
						_max_energy,
						_normal_speed_energy,
						_massive_speed_energy,
						_movement_energy,
						_movement_max_energy,
						_movement_energy_recover_rate,
						_movement_energy_recover_trigger,
						_movement_energy_recover_counter,
						_straight_jumping, # Straight jump from here - new
						_straight_jump_max_speed,
						_straight_jump_increment,
						_straight_jump_speed_normal,
						_straight_jump_speed_burst,	
						_straight_jump_up,
						_straight_jump_down,
						_straight_jump_energy,
						_normal_straight_jump_energy,
						_massive_straight_jump_energy,
						_straight_jump_energy_recover_rate,
						_straight_jump_energy_recover_trigger,
						_straight_jump_energy_recover_counter,
						_straight_jump_max_energy,
						_fireflies_decrement ):
		"""

		"""
		pygame.sprite.Sprite.__init__( self )

		# Initial settings.
		self.animation_interval 	= _animation_interval
		self.movement_status 		= _movement_status
		
		self.animation_right_dir 	= AnimatedSprite( _images_right_dir,
													  self.animation_interval )
		
		self.animation_left_dir 	= AnimatedSprite( _images_left_dir,
													  self.animation_interval )

		# Further settings.
		self.image 									= self.animation_right_dir.image
		self.rect 									= self.animation_right_dir.rect

		self.rect.left 								= _left_top_position[0]
		self.rect.top 								= _left_top_position[1]

		self.direction 								= _direction
		self.jumping 								= _jumping
		self.jump_max_speed 						= _jump_max_speed
		self.jump_increment 						= _jump_increment
		self.jump_speed_normal						= _jump_speed_normal
		self.jump_up 								= _jump_up
		self.jump_down 								= _jump_down
		self.movement_speed_normal					= _movement_speed_normal
		self.energy 								= _energy
		self.normal_jump_energy 					= _normal_jump_energy
		self.massive_jump_energy 					= _massive_jump_energy
		self.movement_speed_burst					= _movement_speed_burst
		self.jump_speed_burst						= _jump_speed_burst
		self.energy_recover_rate					= _energy_recover_rate
		self.energy_recover_trigger					= _energy_recover_trigger
		self.energy_recover_counter 				= _energy_recover_counter
		self.max_energy								= _max_energy
		self.normal_speed_energy					= _normal_speed_energy
		self.massive_speed_energy					= _massive_speed_energy
		self.movement_energy						= _movement_energy
		self.movement_max_energy					= _movement_max_energy
		self.movement_energy_recover_rate			= _movement_energy_recover_rate
		self.movement_energy_recover_trigger		= _movement_energy_recover_trigger
		self.movement_energy_recover_counter		= _movement_energy_recover_counter

		# Variables related to straight jumping.
		self.straight_jumping						= _straight_jumping
		self.straight_jump_max_speed				= _straight_jump_max_speed
		self.straight_jump_increment				= _straight_jump_increment
		self.straight_jump_speed_normal				= _straight_jump_speed_normal
		self.straight_jump_speed_burst				= _straight_jump_speed_burst		
		self.straight_jump_up						= _straight_jump_up
		self.straight_jump_down						= _straight_jump_down
		self.straight_jump_energy					= _straight_jump_energy
		self.normal_straight_jump_energy			= _normal_straight_jump_energy
		self.massive_straight_jump_energy			= _massive_straight_jump_energy
		self.straight_jump_energy_recover_rate		= _straight_jump_energy_recover_rate
		self.straight_jump_energy_recover_trigger	= _straight_jump_energy_recover_trigger
		self.straight_jump_energy_recover_counter	= _straight_jump_energy_recover_counter
		self.straight_jump_max_energy				= _straight_jump_max_energy
		
		self.movement_speed							= self.movement_speed_normal
		self.jump_speed 							= self.jump_speed_normal
		self.straight_jump_speed					= self.straight_jump_speed_normal

		self.performing_straight_jump				= False

		self.current_speed							= 0

		self.fireflies								= 0
		self.fireflies_decrement					= _fireflies_decrement


	def has_fireflies( self ):
		"""

		"""
		if self.fireflies > 0:
			return True
		else:
			return False


	def reduce_fireflies( self ):
		"""

		"""
		if self.fireflies > 0:
			self.fireflies -= self.fireflies_decrement


	def update( self, _eventlist ):
		"""

		"""
		# Check for keypresses and set dictionary values according to what is
		# pressed.
		for e in _eventlist:
			if e.type == pygame.KEYDOWN:
				if e.key == pygame.K_LEFT:
					self.movement_status["move_left"] = True
					self.movement_status["move_right"] = False
					
				if e.key == pygame.K_RIGHT:
					self.movement_status["move_right"] = True
					self.movement_status["move_left"] = False
					
				if e.key == pygame.K_LCTRL:
					self.movement_status["burst"] = True
					
				if e.key == pygame.K_SPACE:
					self.movement_status["jump"] = True

				if e.key == pygame.K_s and not self.performing_straight_jump: # Ugly, I know. Hehehe. But time is of the essence now (Wednesday).
					self.movement_status["straight_jump"] = True
					
			if e.type == pygame.KEYUP:
				if e.key == pygame.K_LEFT:
					self.movement_status["move_left"] = False
					
				if e.key == pygame.K_RIGHT:
					self.movement_status["move_right"] = False
					
				if e.key == pygame.K_LCTRL:
					self.movement_status["burst"] = False
					
				if e.key == pygame.K_SPACE:
					self.movement_status["jump"] = False

				if e.key == pygame.K_s:
					self.movement_status["straight_jump"] = False

		# Check whether the straight jump needs to be performed and can be
		# performed.
		if self.movement_status["straight_jump"] and self.is_on_ground() and \
		not	self.performing_straight_jump:
			self.performing_straight_jump = True

		if self.performing_straight_jump:
			self.deactivate_other_movements()		
					
		# Make the jungleguy move around and jump.
		self.move()

		# Jump energy recover
		if self.check_regenerate_jump_energy():
			self.regenerate_jump_energy()
			self.reset_energy_recover_counter()
		else:
			self.count_up_energy_recover_counter()

		# Movement energy recover
		if self.check_regenerate_movement_energy():
			self.regenerate_movement_energy()
			self.reset_movement_energy_recover_counter()
		else:
			self.count_up_movement_energy_recover_counter()

		# Straight jump energy recover
		if self.check_regenerate_straight_jump_energy():
			self.regenerate_straight_jump_energy()
			self.reset_straight_jump_energy_recover_counter()
		else:
			self.count_up_straight_jump_energy_recover_counter()

		# Make sure the player (our jungleguy) does not leave the playing area.
		if self.rect.bottom > settings.WINDOW_HEIGHT:
			self.rect.bottom = settings.WINDOW_HEIGHT

		if self.rect.top < 0:
			self.rect.top = 0

		if self.rect.right > settings.WINDOW_WIDTH:
			self.rect.right = settings.WINDOW_WIDTH

		if self.rect.left < 0:
			self.rect.left = 0
						

	def move( self ):
		"""

		"""
		# Check whether to go fast or normal (Jumping)
		if self.movement_status["jump"] and self.check_jump_energy():
			if self.movement_status["burst"]:
				self.jump_max_speed = self.jump_speed_burst
				self.jump_speed = self.jump_speed_burst
			else:
				self.jump_max_speed = self.jump_speed_normal
				self.jump_speed = self.jump_speed_normal

		# Check whether to go fast or normal (Moving)
		if self.movement_status["move_left"] or self.movement_status["move_right"]:
			if self.movement_status["burst"]:
				self.movement_speed = self.movement_speed_burst
			else:
				self.movement_speed = self.movement_speed_normal

		# Straight jumping - Check whether to go normal or fast.
		if self.movement_status["straight_jump"] and self.check_straight_jump_energy():
			if self.movement_status["burst"]:
				self.straight_jump_max_speed = self.straight_jump_speed_burst
				self.straight_jump_speed = self.straight_jump_speed_burst
			else:
				self.straight_jump_max_speed = self.straight_jump_speed_normal
				self.straight_jump_speed = self.straight_jump_speed_normal		

		# Movement to the left
		if self.movement_status["move_left"]:
			if self.check_movement_energy():
				self.use_movement_energy()
				self.rect.move_ip( -self.movement_speed, 0 )
				self.direction["left"] = True
				self.direction["right"] = False			
				if self.direction["left"]:
					if not self.jumping:
						self.animation_left_dir.update()
					self.image = self.animation_left_dir.image

		# Movement to the right	
		if self.movement_status["move_right"]:
			if self.check_movement_energy():
				self.use_movement_energy()
				self.rect.move_ip( self.movement_speed, 0 )
				self.direction["right"] = True
				self.direction["left"] = False					
				if self.direction["right"]:
					if not self.jumping:
						self.animation_right_dir.update()			
					self.image = self.animation_right_dir.image

		# Jump
		if self.movement_status["jump"]:			
			if self.check_jump_energy():
				self.use_jump_energy()
				self.movement_status["jump"] = False
				self.jumping = True
				self.jump_up = True
				self.jump_down = False

		# Straight jump
		if self.movement_status["straight_jump"]:
			if self.check_straight_jump_energy():
				self.use_straight_jump_energy()
				self.movement_status["straight_jump"] = False
				self.straight_jumping = True
				self.straight_jump_up = True
				self.straight_jump_down = False
			else:
				self.performing_straight_jump = False
				self.straight_jumping = False

		# Jump if necessary.
		if self.jumping:
			self.jump()

		# Straight jump if necessary.
		if self.straight_jumping and self.performing_straight_jump:
			self.perform_straight_jump()


	def check_jump_energy( self ):
		"""Jumping

		"""
		if self.movement_status["burst"]:
			if self.energy >= self.massive_jump_energy:
				return True
			else:
				return False
		else:
			if self.energy >= self.normal_jump_energy:
				return True
			else:
				return False


	def check_movement_energy( self ):
		"""Walking

		"""
		if self.movement_status["burst"]:
			if self.movement_energy >= self.massive_speed_energy:
				return True
			else:
				return False
		else:
			if self.movement_energy >= self.normal_speed_energy:
				return True
			else:
				return False


	def check_straight_jump_energy( self ):
		"""Walking

		"""
		if self.movement_status["burst"]:
			if self.straight_jump_energy >= self.massive_straight_jump_energy:
				return True
			else:
				return False
		else:
			if self.straight_jump_energy >= self.normal_straight_jump_energy:
				return True
			else:
				return False	


	def use_jump_energy( self ):
		"""Jumping

		"""
		if self.movement_status["burst"]:
			self.energy -= self.massive_jump_energy
		else:
			self.energy -= self.normal_jump_energy


	def use_movement_energy( self ):
		"""Walking

		"""
		if self.movement_status["burst"]:
			self.movement_energy -= self.massive_speed_energy
		else:
			self.movement_energy -= self.normal_speed_energy


	def use_straight_jump_energy( self ):
		"""Straight jumping

		"""
		if self.movement_status["burst"]:
			self.straight_jump_energy -= self.massive_straight_jump_energy
		else:
			self.straight_jump_energy -= self.normal_straight_jump_energy


	def jump( self ):
		"""Performs the jump if the player wants to jump.

		"""
		if self.jump_up:
			self.jump_speed -= self.jump_increment
			if self.jump_speed <= 0:
				self.jump_down = True
				self.jump_up = False
				self.jump_speed = 0
			else:
				self.rect.bottom -= self.jump_speed

		if self.rect.bottom < settings.WINDOW_HEIGHT and not self.jump_up:
			self.jump_speed += self.jump_increment
			if self.rect.bottom >= settings.WINDOW_HEIGHT:
				self.jump_down = False
				self.jump_up = False
				self.jumping = False
				self.jump_speed = self.jump_max_speed
			else:
				self.rect.bottom += self.jump_speed
				if self.rect.bottom >= settings.WINDOW_HEIGHT:
					self.jump_down = False
					self.jump_up = False
					self.jumping = False
					self.jump_speed = self.jump_max_speed

		self.current_speed = math.fabs( self.jump_speed )


	def perform_straight_jump( self ):
		"""Performs the straight jump.  During this special jump, the player
		can not move to the left or the right or use the other jump.

		"""
		if self.straight_jump_up:
			self.straight_jump_speed -= self.straight_jump_increment
			if self.straight_jump_speed <= 0:
				self.straight_jump_down = True
				self.straight_jump_up = False
				self.straight_jump_speed = 0
			else:
				self.rect.bottom -= self.straight_jump_speed

		if not self.straight_jump_up:
			self.straight_jump_speed += self.straight_jump_increment
			if self.rect.bottom >= settings.WINDOW_HEIGHT:
				self.straight_jump_down = False
				self.straight_jump_up = False
				self.straight_jumping = False
				self.straight_jump_speed = self.straight_jump_max_speed
				self.performing_straight_jump = False
			else:
				self.rect.bottom += self.straight_jump_speed

		self.current_speed = math.fabs( self.straight_jump_speed )


	def check_regenerate_jump_energy( self ):
		"""

		"""	
		if ( self.energy_recover_counter > self.energy_recover_trigger ) and \
		   ( self.energy < self.max_energy ):
			return True
		else:
			return False


	def regenerate_jump_energy( self ):
		"""

		"""
		self.energy += self.energy_recover_rate
		if self.energy > self.max_energy:
			self.energy = self.max_energy


	def reset_energy_recover_counter( self ):
		"""

		"""
		self.energy_recover_counter = 0


	def count_up_energy_recover_counter( self ):
		"""

		"""
		self.energy_recover_counter += 1


	def check_regenerate_movement_energy( self ):
		"""

		"""
		if ( self.movement_energy_recover_counter > self.movement_energy_recover_trigger ) and \
		   ( self.movement_energy < self.movement_max_energy ):
			return True
		else:
			return False

					
	def regenerate_movement_energy( self ):
		"""

		"""
		self.movement_energy += self.movement_energy_recover_rate
		if self.movement_energy > self.movement_max_energy:
			self.movement_energy = self.movement_max_energy	
			
	def reset_movement_energy_recover_counter( self ):
		"""

		"""
		self.movement_energy_recover_counter = 0

			
	def count_up_movement_energy_recover_counter( self ):
		"""

		"""
		self.movement_energy_recover_counter += 1


	def is_on_ground( self ):
		"""Returns True if the jungleguy is positioned on the ground.

		"""
		if self.rect.bottom == settings.WINDOW_HEIGHT:
			return True
		else:
			return False


	def deactivate_other_movements( self ):
		"""Deactivates all movements except the straight jump.

		"""
		self.movement_status["move_left"] = False
		self.movement_status["move_right"] = False
		self.movement_status["jump"] = False
		self.jumping = False
		self.jump_up = False
		self.jump_down = False


	def check_regenerate_straight_jump_energy( self ):
		"""Straight jump energy validation.

		"""
		if ( self.straight_jump_energy_recover_counter > self.straight_jump_energy_recover_trigger ) and \
		   ( self.straight_jump_energy < self.straight_jump_max_energy ):
			return True
		else:
			return False

					
	def regenerate_straight_jump_energy( self ):
		"""Straight jump regeneration.

		"""
		self.straight_jump_energy += self.straight_jump_energy_recover_rate
		if self.straight_jump_energy > self.straight_jump_max_energy:
			self.straight_jump_energy = self.straight_jump_max_energy	
			
	def reset_straight_jump_energy_recover_counter( self ):
		"""Straight jump counter reset.

		"""
		self.straight_jump_energy_recover_counter = 0

			
	def count_up_straight_jump_energy_recover_counter( self ):
		"""Straight jump counter increment.

		"""
		self.straight_jump_energy_recover_counter += 1		
