import pygame
pygame.init()

import helpers
import settings


class Menu( object ):
	"""

	"""
	def __init__( self, _data ):
		"""

		"""
		self.data = _data

		self.create_heading( _data["heading"] )
		self.create_menu_items( _data["menu_items"] )
		self.selected_item = 1
		self.max_items = len( self.menu_items )
		self.change_selection( self.selected_item )


	def update( self, _eventlist ):
		"""

		"""
		for x in _eventlist:
			if x.type == pygame.KEYDOWN:
				if x.key == pygame.K_DOWN:
					if ( self.selected_item + 1 ) <= self.max_items:
						self.selected_item += 1
						self.change_selection( self.selected_item )
				if x.key == pygame.K_UP:
					if self.selected_item > 1:
						self.selected_item -= 1
						self.change_selection( self.selected_item )

				if x.key == pygame.K_RETURN:
					return self.return_item_return_value()
					

	def return_item_return_value( self ):
		"""

		"""
		for m in self.menu_items:
			if m.index == self.selected_item:
				return m.ret_value
				

	def create_heading( self, _data ):
		"""

		"""
		font = helpers.load_font( _data["font"], _data["font_size"] )
		self.heading = pygame.sprite.Sprite()
		self.heading.image = font.render( _data["text"],
									   True,
									   _data["fgcolor"]
									   )
		self.heading.rect = self.heading.image.get_rect()
		self.heading.rect.center = _data["center"]


	def create_menu_items( self, _data ):
		"""

		"""
		self.menu_items = pygame.sprite.Group()
		font = helpers.load_font( _data["font"], _data["font_size"] )
		self.selected_color = _data["selected_color"]
		for m in _data["menu_items"].itervalues():

			self.create_menu_item( m, font )


	def create_menu_item( self, _data, _font ):
		"""

		"""
		self.menu_item = pygame.sprite.Sprite()
		self.menu_item.image = _font.render( _data["text"],
									   True,
									   _data["fgcolor"]
									   )
		self.menu_item.image_active = _font.render( _data["text"],
									   True,
									   self.selected_color
									   )
		self.menu_item.image_inactive = _font.render( _data["text"],
									   True,
									   _data["fgcolor"]
									   )									   									   
									   
		self.menu_item.rect = self.menu_item.image.get_rect()
		self.menu_item.rect.center = _data["center"]
		self.menu_item.index = _data["index"]
		self.menu_item.ret_value = _data["ret_value"]

		self.menu_items.add( self.menu_item )


	def change_selection( self, _index ):
		"""

		"""
		for m in self.menu_items:
			if m.index == _index:
				m.image = m.image_active
			else:
				m.image = m.image_inactive
				

	def draw( self, _window ):
		"""

		"""
		_window.blit( self.heading.image, self.heading.rect )
		self.menu_items.draw( _window )
