import pygame
pygame.init()

import settings
import helpers


class RootArea( pygame.sprite.Sprite ):
	"""

	"""
	sound = helpers.load_sound( "waterdrop.ogg" )
	
	def __init__( self, _image_path,
						_pos_center_bottom,
						_water_increment,
						_water_decrement,
						_max_timer,
						_timer_increment ):
		"""

		"""
		self.image = helpers.load_image( _image_path )
		self.rect = self.image.get_rect()
		self.rect.centerx = _pos_center_bottom[0]
		self.rect.bottom = _pos_center_bottom[1]
		self.water_increment = _water_increment
		self.water_decrement = _water_decrement

		self.water_in_soil = 0

		self.timer = 0
		self.timer_max = _max_timer
		self.timer_increment = _timer_increment


	def update( self, _raindrops ):
		"""

		"""
		if self.water_in_soil:
			if self.timer >= self.timer_max:
				self.timer = 0
				self.reduce_water()
			else:
				self.timer += 1
				
		if self.check_raindrop_fallen_on_area( _raindrops ):
			self.increase_water_in_soil()


	def check_raindrop_fallen_on_area( self, _raindrops ):
		"""

		"""
		for r in _raindrops:
			if not r.already_counted:
				if self.rect.colliderect( r.rect ):
					r.already_counted = True
					return True
		return False


	def increase_water_in_soil( self ):
		"""

		"""
		self.water_in_soil += self.water_increment
		RootArea.sound.play()


	def has_water( self ):
		if self.water_in_soil > 0:
			return True
		else:
			return False


	def reduce_water( self ):
		if self.water_in_soil > 0:
			self.water_in_soil -= self.water_decrement
