import pygame
pygame.init()

import copy

import helpers
import random


class Turbine( pygame.sprite.Sprite ):
	"""

	"""
	sound = helpers.load_sound( "turbine_sound.ogg" )
	
	def __init__( self, _image_path,
						_left_top_position,
						_cur_angle,
						_angle_amount,
						_upwards,
						_downwards,
						_down_limit,
						_up_limit,
						_movement_speed,
						_moving_up,
						_moving_down,
						_already_touched,
						_can_generate_energy,
						_slow_down_amount,
						_energy_increment ):
		"""

		"""
		pygame.sprite.Sprite.__init__( self )

		self.orig_image 			= helpers.load_image( _image_path )
		self.orig_left_top_position = copy.deepcopy( _left_top_position )
		self.image 					= self.orig_image.copy()
		self.rect 					= self.image.get_rect()
		self.rect.left 				= _left_top_position[0]
		self.rect.top 				= _left_top_position[1]
		self.cur_angle 				= _cur_angle
		self.angle_amount 			= _angle_amount
		self.upwards 				= _upwards
		self.downwards 				= _downwards
		self.down_limit 			= _down_limit
		self.up_limit 				= _up_limit
		self.movement_speed 		= _movement_speed
		self.moving_up 				= _moving_up
		self.moving_down 			= _moving_down
		self.already_touched 		= _already_touched
		self.can_generate_energy 	= _can_generate_energy
		self.slow_down_amount 		= _slow_down_amount

		self.energy_increasement_amount	= _energy_increment
		self.max_angle = 359


	def update( self, _player, _lamp ):
		"""

		"""
		if self.can_generate_energy:
			self.cur_angle += self.angle_amount
			if self.cur_angle > self.max_angle:
				_lamp.increase_energy( self.energy_increasement_amount )
				self.cur_angle = 0

			orig_xy = copy.deepcopy( self.rect.center )
			
			self.image = pygame.transform.rotate( self.orig_image, self.cur_angle )
			self.rect = self.image.get_rect( center = orig_xy)

			if self.angle_amount <= 0:
				self.can_generate_energy = False
				self.angle_amount = 0
			else:
				self.angle_amount -= self.slow_down_amount


		if self.moving_down:
			if self.can_move_downwards():
				self.move_downwards()
			else:
				self.moving_down = False
				self.moving_up = True

		if self.moving_up:
			if self.can_move_upwards():
				self.move_upwards()
			else:
				self.moving_up = False
				self.moving_down = True

		self.collision_with_player( _player )


	def collision_with_player( self, _player ):
		"""

		"""
		if self.rect.colliderect( _player.rect ) and not self.already_touched:
			self.already_touched = True
			self.can_generate_energy = True
			self.angle_amount = _player.current_speed
			Turbine.sound.play()
		else:
			self.already_touched = False


	def can_move_downwards( self ):
		"""Returns True if the turbine can move downwards.

		"""
		if self.rect.bottom <= self.down_limit:
			return True
		else:
			return False


	def can_move_upwards( self ):
		"""Returns True if the turbine can move upwards.

		"""
		if self.rect.top >= self.up_limit:
			return True
		else:
			return False


	def move_downwards( self ):
		"""Moves the turbine downwards.

		"""
		self.rect.move_ip( 0, self.movement_speed )


	def move_upwards( self ):
		"""Moves the turbine upwards.

		"""
		self.rect.move_ip( 0, -self.movement_speed )
