import os
import pygame
pygame.init()

import settings

def load_image( _filename ):
	"""

	"""
	img = pygame.image.load(
		os.path.join(
			os.getcwd(),
			settings.GFX_DIR,
			_filename
		)
	)
	
	img.set_colorkey( settings.WHITE )
	
	return img


def load_level( _filename ):
	"""

	"""
	file_handle = open(
		os.path.join(
			os.getcwd(),
			settings.LEVEL_DIR,
			_filename
		)
	)
	
	contents = file_handle.read().splitlines()
	file_handle.close()

	return contents


def load_font( _font_name, _size ):
	"""

	"""
	p = os.path.join( os.getcwd(), settings.FONT_DIR, _font_name )
	return pygame.font.Font(
		os.path.join(
			os.getcwd(),
			settings.FONT_DIR,
			_font_name
		),
		_size
	)


def load_sound( _filename ):
	return pygame.mixer.Sound( os.path.join( os.getcwd(), settings.SOUND_DIR, _filename ) )


def load_music( _filename ):
	 pygame.mixer.music.load( os.path.join( os.getcwd(), settings.MUSIC_DIR, _filename ) )


def move_other_game_objects( _game_objects, _movement_horizontal ):
	"""

	"""
	for game_object in _game_objects:
		game_object.move_horizontal( _movement_horizontal )
